<template>
    <div id="page" class="orderCreate position-relative h-100" ref="page">
        <OrderCreateInfo ref="panel" @getRecommendations="calculate" />
        <ColumnVisibilityPanel
            :show="columnsSettingsShow"
            @update:show="toggleColumnSettings($event)"
        />
        <div
            v-if="isCalculated"
            :class="[
                `orderTableWrapper`,
                { tableWrapperFullscreen: isFullscreenTable }
            ]"
            ref="tableWrapper"
            @mouseover="mouseOver"
            @mouseleave="mouseLeave"
        >
            <CRow align-horizontal="end" class="mw-100 mb-3 p-1">
                <CCol>
                    <CButton
                        class="ml-auto"
                        color="dark"
                        variant="ghost"
                        @click="tableFullscreen()"
                    >
                        {{isFullscreenTable ? 'Свернуть' : 'Развернуть таблицу на весь экран' }}
                    </CButton>
                </CCol>
                <CCol :sm="{ offset: 'auto' }">
                    <CButtonGroup>
                        <CButton
                            class="ml-auto"
                            color="dark"
                            variant="ghost"
                            @click="toggleColumnSettings()"
                        >
                            Настроить таблицу
                        </CButton>
                        <CButton color="dark"
                                 variant="ghost" @click="toggleLegend()">
                            Показать легенду
                        </CButton>
                        <CButton color="dark"
                                 variant="ghost" @click="exportTable()">
                            Скачать всю таблицу в XLS
                        </CButton>
                    </CButtonGroup>
                </CCol>
            </CRow>
            <q-table
                title=""
                :data="items"
                :columns="columnKeys"
                :table-colspan="columnKeys.length"
                row-key="index"
                :rows-per-page-options="[0]"
                :virtual-scroll-item-size="isFullscreenTable ? 48 : 12"
                :virtual-scroll-sticky-size-start="48"
                :virtual-scroll-sticky-size-end="32"
                :items="items"
                ref="table"
                virtual-scroll
                :class="[
                    `orderTable`,
                    `mb-2`,
                    {
                        tableFullscreen: isFullscreenTable,
                        tableNotEmpty: !!items.length
                    }
                ]"
                :pagination.sync="initialPagination"
                hide-pagination
                :visible-columns="visibleFields"
            >
                <template v-if="!isFullscreenTable" #bottom>
                    <CRow class="w-100">
                        <CCol sm="4" class="d-flex justify-start">
                            <CSelect
                            label="Строк в таблице"
                            :options="[10,20,30,40,50]"
                            :horizontal="{ label: 'col-sm-6', input: 'col-sm-6'}"
                            class="w-100 align-content-center font-sm"
                            :value.sync="initialPagination.rowsPerPage"
                        />
                        </CCol>
                        <CCol sm="4" class="d-flex justify-center">
                            <q-pagination
                            v-model="initialPagination.page"
                            color="grey-8"
                            :max="pagesNumber"
                            :max-pages="5"
                            size="md"
                            :boundary-numbers="true"
                        />
                        </CCol>
                        <CCol sm="4" class="d-flex justify-content-end align-items-center">
                            <CLink class="font-sm text-dark" @click="initialPagination.page = 1">
                                Вернуться в начало
                            </CLink>
                        </CCol>
                    </CRow>
                </template>

                <template v-slot:header="props">
                    <q-tr
                        v-for="(row, index) in fields"
                        :key="`th-row-${index}`"
                        :props="props"
                    >
                        <q-th
                            v-for="col in row"
                            :key="`th-${index}--${col.field}`"
                            :colspan="col.colspan"
                            :rowspan="col.rowspan"
                            :style="col._style"
                            :class="[col._classes, `text-${col.align}`]"
                        >
                            <div class="tableHeadInner">
                                {{ col.label }}
                                <div class="colResizer" @mousedown.left="hold($event, col.name)" />
                            </div>
                        </q-th>
                    </q-tr>
                </template>

                <template #body-cell="props">
                    <q-td
                        :props="props"
                        :style="[
                            ...props.col._style,
                            {
                            left: props.col.params.sticky ? `${props.col.params.left}px` : null
                        }]"
                        :class="[
                            props.col._classes,
                            {
                                'position-sticky': props.col.params.sticky,
                                'cellBg-promo' : (props.col.params.parent && (props.col.params.index > props.row.promoStartWeek || props.col.params.index < props.row.promoEndWeek))
                            }
                        ]"
                    >
                        <div class="tableCellInner">
                            {{ props.value }}
                            <div class="colResizer" @mousedown.left="hold($event, props.col.name)" />
                            <div class="rowResizer" @mousedown.left="hold($event, props.col.name, 'v')" />
                        </div>
                    </q-td>
                </template>

                <template v-slot:body-cell-comment="props">
                    <q-td :props="props">
                        <CButton
                            variant="ghost"
                            class="commentButton"
                            @click="toggleCommentForm(true, {comment: props.value, id: props.row.id})"
                        >
                            <CIcon v-if="props.value" name="cil-comment-bubble" size="xl" />
                            <svg v-else id="cis-comment-bubble" viewBox="0 0 512 512" class="c-icon c-icon-xl">
                                <path fill="var(--ci-primary-color, currentColor)" d="M409.407,351.988l-.535-1.516C452.634,316.89,480,269.074,480,216,480,114.38,379.712,32,256,32S32,114.38,32,216,132.288,400,256,400a274.016,274.016,0,0,0,33.348-2.032l22.106,19.159A257.353,257.353,0,0,0,480,480h0V464h0A299.274,299.274,0,0,1,409.407,351.988Z" class="ci-primary"></path>
                            </svg>
                        </CButton>
                    </q-td>
                </template>
                <template v-slot:body-cell-order="props">
                    <q-td
                        :props="props"
                        :style="[
                            ...props.col._style,
                            {
                            left: props.col.params.sticky ? `${props.col.params.left}px` : null
                        }]"
                        :class="cellBgChanged(props.row)"
                    >
                        <form class="tableCellInner" @submit.prevent="orderCountEdit(props.row.id,props.row.order_new)">
                            <CInput :value="props.row.order" type="number" @input="$set(props.row, 'order_new', $event)" min="0" />
                            <div class="colResizer" @mousedown.left="hold($event, props.col.name)" />
                            <div class="rowResizer" @mousedown.left="hold($event, props.col.name, 'v')" />
                        </form>
                    </q-td>
                </template>
                <template v-slot:body-cell-sum="props">
                    <q-td :props="props">
                        <div class="tableCellInner">
                            {{ props.row.order * props.row.supplyPrice }}
                            <div class="colResizer" @mousedown.left="hold($event, props.col.name)" />
                            <div class="rowResizer" @mousedown.left="hold($event, props.col.name, 'v')" />
                        </div>
                    </q-td>
                </template>
                <template #no-data>
                    <TableNoData />
                </template>
            </q-table>
        </div>
        <color-hint
            :show="legendShow"
            :items="hintItems"
            @update:show="toggleLegend($event)"
        />
        <CModal :show.sync="commentFormShow" centered color="primary" size="lg">
            <template #header>
                <div>
                    <div class="font-weight-bold font-2xl">
                        Оставить комментарий
                    </div>
                    Укажите причину изменения этого заказа
                </div>
            </template>
            <CTextarea :value.sync="comment" />
            <template #footer>
                <CButton type="success" @click="saveComment">Сохранить</CButton>
            </template>
        </CModal>
        <CToaster
            v-for="(toaster, toasterKey) in toasters"
            :position="toasterKey"
            :key="'toaster' + toasterKey"
        >
            <template v-for="(toast, key) in toaster">
                <CToast
                    :key="'toast' + key"
                    :show="true"
                    v-bind="toast"
                >
                    {{`This is a toast in ${toasterKey} positioned toaster number ${key + 1}.`}}
                </CToast>
            </template>
        </CToaster>
    </div>
</template>

<script>
import '../utils/datetime'
import { exportFile } from 'quasar'

function wrapCsvValue (val, formatFn) {
    let formatted = formatFn !== void 0
        ? formatFn(val)
        : val

    formatted = formatted === void 0 || formatted === null
        ? ''
        : String(formatted)

    formatted = formatted.split('"').join('""')
    /**
     * Excel accepts \n and \r in strings, but some other CSV parsers do not
     * Uncomment the next two lines to escape new lines
     */
    // .split('\n').join('\\n')
    // .split('\r').join('\\r')

    return `"${formatted}"`
}
export default {
    name: `NewOrder`,
    data() {
        return {
            hintItems: [
                {
                    label: `Недели, в которые проходят акции на товар`,
                    color: `rgba(102, 204, 0, 0.2)`
                },
                {
                    label: `Внесено изменение относительно автозаказа`,
                    color: `rgba(255, 153, 0, 0.2)`
                },
            ],
            theadRow: [],
            columnsSettingsShow: false,
            legendShow: false,
            commentFormShow: false,
            comment: null,
            commentItemId: null,
            isFullscreenTable: false,
            tableSettings: {
                sorter: false,
                hover: true,
                striped: true,
                border: false,
                header: true,
            },
            stickyFields: [`id`, `platform`, `brand`, `name`],
            holdingKey: null,
            offset: 0,
            startOffset: 0,
            resizableEl: null,
            initialPagination: {
                sortBy: 'desc',
                descending: false,
                page: this.isFullscreenTable ? null : 1,
                rowsPerPage: this.isFullscreenTable ? null : 20
            },
            isCalculated: false,
            toasts: [],
            toastConfig () {
                return {
                    autohide: true,
                    closeButton: true,
                    fade: true,
                    position: 'top-right',
                    header: 'Ошибка'
                }
            },
        };
    },
    mounted() {
        document.addEventListener("scroll", this.scroll, { passive: true });
    },
    computed: {
        columns() {
            return this.$store.getters.orderCreateColumns
            .map(item => {
                return {
                    ...item,
                    field: item.name,
                    _style: [...item._style, {minWidth: `${item.params.width}px`, width: `${item.params.width}px`}]
                }
            })
        },
        visibleFields() {
            return this.$store.getters.getVisibleFields
        },
        fields() { // Подготовка колонок для работы с компонентом таблицы
            const fields = JSON.parse(JSON.stringify(this.columns))
                    .filter(field => (this.visibleFields.includes(field.name)) || !!field.required)
            const secondRow = fields.filter(result => result.children); //Вывод на вторую строку шапки только столбцов, являющихся вложенными
            const firstRow = fields.map((field) => { // Вывод на первую строку только столбцов, не имеющих вложенных
                      return {
                          ...field,
                          _classes: field._classes || [],
                          _style: [
                              ...field._style,
                              {left: field.params.sticky ? `${field.params.left}px` : null} //Необхожимость присваивания свойства left для закрепленных столбцов
                              ],
                          align: field.align || 'center',
                          rowspan: field.children ? 1 : 2,
                          colspan: field.children ? field.children.length : 1,
                      };
                  })
            secondRow
                .forEach((item, index, array) => { // Извлечение вложенных столбцов и их перенос на верхний уровень
                    if (!item._classes) item._classes = [];
                    if (!item._style) item._style = [];
                    array.splice(index, 1);
                    if (item.children) {
                        array.splice.apply(array, [index, 0].concat(item.children));
                    }
                })
            return [firstRow, secondRow];
        },
        columnKeys() {
            const columns = JSON.parse(JSON.stringify(this.columns))
            columns.forEach((item, index, array) => {
                if (item.children) {
                    array.splice(index, 1);
                    array.splice.apply(array, [index, 0].concat(item.children));
                }
            })
            return columns
        },
        items() { // Получение рекомендаций из vuex хранилища и подготовка полей для использования с компонентом таблицы
            return this.$store.getters.getRecommendations
            .map((item) => {
                item.products = item.products || {daily_product_statistics: {}, supplier: {}}
                item.daily_product_statistics = item.daily_product_statistics || {}
                item.supplier = item.supplier || {}
                Object.entries(item.last_weeks_sales).forEach(([index, el]) => {
                    item[`last_weeks_sales-${index}`] = `${el}`
                })
                return {
                    ...item,
                    platform: item.platform_name,
                    size: `${item.size_a}x${item.size_b}x${item.size_c}`,
                    actualTurnover: item.last_daily_product_statistics[0].actual_turnover,
                    thresholdTurnover: item.last_daily_product_statistics[0].threshold_turnover,
                    realTurnover: item.last_daily_product_statistics[0].real_turnover,
                    recommendedOrder: item.recommended_order,
                    calculatedOrder: item.calculated_order,
                    order: item.order_new || item.manager_order,
                    order_old: item.manager_order,
                    supplyPrice: item.supply_price,
                    minCount: item.min_purchase_number,
                    shipmentMultiplicity: item.shipment_multiplicity,
                    minSiteShipment: item.platform_name === 'Wildberries' ? item.min_wb_shipment : '-',
                    siteShipmentMultiplicity: item.shipment_multiplicity,
                    minAmount: item.supplier.min_order_price,
                    nomenclatureStatus: item.nomenclature_status_id,
                    supplierSku: item.nomenclature_status_id,
                    promoStartDate: item.promo_start_date,
                    promoEndDate: item.promo_end_date,
                    productsIncoming: item.last_daily_product_statistics[0].products_incoming,
                    productsRemain: item.last_daily_product_statistics[0].products_remain,
                    warehouse: item.warehouse_name,
                    ABCxyz: item.last_daily_product_statistics[0].ABC_XYZ,
                    changed: false,
                    promoStartWeek: new Date(item.promo_start_date).getWeek(),
                    promoEndWeek: new Date(item.promo_end_date).getWeek(),
                    saleDays: item.last_weeks_total_sales,
                }
            })
        },
        pagesNumber () {
            return Math.ceil(this.items.length / this.initialPagination.rowsPerPage)
        },
        toasters () {
            return this.toasts.reduce((toasters, toast) => {
                toasters[toast.position] = toasters[toast.position] || []
                toasters[toast.position].push(toast)
                return toasters
            }, {})
        }
    },
    methods: {
        mouseOver() {
            document.querySelector("body").classList.add("overflow-hidden");
        },
        mouseLeave() {
            document.querySelector("body").classList.remove("overflow-hidden");
        },
        toggleColumnSettings(value = null) {
            this.columnsSettingsShow = value
                ? value
                : !this.columnsSettingsShow;
        },
        toggleLegend(value = null) {
            this.legendShow = value ? value : !this.legendShow;
        },
        toggleCommentForm(value, {id, comment} = {}) {
            this.commentFormShow = value;
            this.comment = value ? comment : null;
            this.commentItemId = value ? id : null;
        },
        saveComment() {
            this.$store.dispatch('saveComment', {id: this.commentItemId, value: this.comment})
            .then(() => {
                this.$store.dispatch('toast/addToast', {
                    toastInfo: 'Данные сохранены',
                    isVisibleToast: 1,
                    type: 'success'
                })
            })
            const editedItem = this.items.find(result => result.id === this.commentItemId)
            editedItem.comment = this.comment;
            this.$store.commit('addEditedProducts', editedItem)
            this.toggleCommentForm(false);
        },
        tableFullscreen(value = null) {
            this.isFullscreenTable = value || !this.isFullscreenTable;
            this.initialPagination.rowsPerPage = this.isFullscreenTable ? null : 20
        },
        hold(e, key, direction = 'h') { // Событие удерживания левой кнопки мыши на краю ячейки для изменения ее ширины/высоты
            this.holding = true
            const el = e.target.parentNode.parentNode
            this.resizableEl = el
            this.startOffset = (direction === 'h')
                ? el.offsetWidth - e.pageX
                : el.offsetHeight - e.pageY
            this.holdingKey = key
            this.holdingDirection = direction
            el.style.userSelect = 'none'
            document.addEventListener('mousemove',this.moving)
            document.addEventListener('mouseup',this.unhold)
        },
        unhold(){ // Событие при отпускании кнопки мыши при изменении ширины
            this.holding = false
            this.holdingKey = null
            this.holdingDirection = null
            this.resizableEl.style.userSelect = null
            document.removeEventListener('mousemove',this.moving)
            document.removeEventListener('mouseup',this.unhold)
        },
        moving(e) { // Расчет ширины ячейки на основе позиции курсора
            const move = () => window.requestAnimationFrame(
                () => {
                    if (this.holding) {
                        if (this.holdingDirection === 'h') {
                            const width = this.startOffset + e.pageX
                            this.offset = width
                            this.resizableEl.style.minWidth = `${width}px`
                            this.updateLeftOffset()
                            this.$store.dispatch('setColWidth', {width, name: this.holdingKey})
                        } else {
                            const height = this.startOffset + e.pageY
                            this.offset = height
                            this.resizableEl.style.height = `${height}px`
                            this.updateLeftOffset()
                            this.$store.dispatch('setColHeight', {height, name: this.holdingKey})
                        }
                    }
                }
            )
            move()
        },
        updateLeftOffset() { // Обновление смещения для закрепленных столбцов
            let offset = 0
            const firstRow = this.$el.querySelectorAll('thead>tr:nth-child(1) > .left-sticky')
            const tableRows = this.$el.querySelectorAll('tbody>tr')
            this.$el.querySelectorAll('thead>tr:first-child > .left-sticky').forEach((el, index, array) => {
                const setOffset = () => window.requestAnimationFrame(
                    () => {
                        if (index > 0) {
                            const prevEl = array[index - 1]
                            offset += prevEl.clientWidth // Вычисление положения на основе суммы ширины предыдущих колонок
                        }
                        el.style.left = `${offset}px`
                        firstRow[index].style.left = `${offset}px`
                    }
                )
                offset = 0
                setOffset()
                tableRows.forEach(row => {
                    const setBodyCellsOffset = () => window.requestAnimationFrame(
                        () => {
                            if (index > 0) {
                                const currentCell = row.querySelectorAll('.position-sticky')[index]
                                if (currentCell) currentCell.style.left = `${offset}px`
                            }
                        }
                    )
                    setBodyCellsOffset()
                })
            })
        },
        calculate() {
            this.isCalculated = true
            this.updateLeftOffset()
        },
        orderCountEdit(id, value){
            this.$store.dispatch('changeOrderValue', {id, value})
            const editedItem = this.items.find(result => result.id === id)
            this.$set(editedItem, 'order', value)
            this.$store.commit('addEditedProducts', editedItem)
        },
        cellBgChanged({order_old, order_new}) {
            if (order_new && (order_old !== order_new)) {
                return ['cellBg-orderChanged']}
        },
        addToast (message = '') {
            this.toasts.push({
                ...this.toastConfig,
                message
            })
        },
        exportTable () {
            const content = [ this.columns.map(col => wrapCsvValue(col.label)) ].concat(
                this.items.map(row => this.columns.map(col => wrapCsvValue(
                    typeof col.field === 'function'
                        ? col.field(row)
                        : row[col.field === void 0 ? col.name : col.field],
                    col.format
                )).join(','))
            ).join('\r\n')

            const status = exportFile(
                'рекомендации.csv',
                content,
                'text/csv'
            )

            if (status !== true) {
                this.$q.notify({
                    message: 'Browser denied file download...',
                    color: 'negative',
                    icon: 'warning'
                })
            }
        }
    }
};
</script>
